<?php
require('includes/application_top.php');
require ('includes/languages/english/checkout_process.php');
define("EMAIL_SUBJECT_FUNIU_MSG",'Order Status Notification');
define("EMAIL_SUCCESS_FUNIU_MSG",'This email is system generated.  Please do not reply to this email. This letter confirms your SUCCESSFUL status order.'); //Change according to the email content needs for a successful transaction
define("EMAIL_FAIL_FUNIU_MSG",'This email is system generated.  Please do not reply to this email. This letter confirms your FAILED status order. Order is reverted back to Pending Status.'); //Change according to the email content needs for a failed transaction
define("ORDERLINK", HTTP_SERVER . DIR_WS_CATALOG.'index.php?main_page=account_history_info&order_id=');
$response['status ']   = isset($_GET['status']) ? $_GET['status'] : false;
$response['data']      = isset($_GET['data']) ? $_GET['data'] : '';
$response['type']      = isset($_GET['type']) ? $_GET['type'] : '';
$response['code']      = isset($_GET['code']) ? $_GET['code'] : '';
$response['msg']       = isset($_GET['msg']) ? $_GET['msg'] : '';
$response['sign']      = isset($_GET['sign']) ? $_GET['sign'] : '';
$response['timestamp'] = isset($_GET['timestamp']) ? $_GET['timestamp'] : '';
if ( empty($response['data']) ){
    $messageStack->add_session('checkout_payment', $response['msg'], 'error');
    zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
    exit;
}

if ( $response['code'] == '301'){
    // 3d验证
    certification3d($response);
}

$funiu_config = get_payment_config();
$funiu_config = json_decode($funiu_config,true);
$response['payFailure'] = $funiu_config['messages']['payFailure'];

$order_prefix_status = ((MODULE_PAYMENT_FUNIU_ORDER_PREFIX_STATUS == 'True') ? true : false);
$order_prefix = MODULE_PAYMENT_FUNIU_ORDER_PREFIX;
$response['merNo']     = trim(MODULE_PAYMENT_FUNIU_SELLER); // 商户编号
$response['md5Key']    = trim(MODULE_PAYMENT_FUNIU_MD5KEY); // MD5私钥

$tradeInfo = json_decode(base64_decode($response['data']), true);
$response['orderNo'] = $tradeInfo['orderNo']; //订单号
$response['tradeNo'] = $tradeInfo['tradeNo']; //交易流水号
if ($order_prefix_status){
    $response['orderNo'] = substr($response['orderNo'],strlen($order_prefix));
}
//订单是否存在
$query = "SELECT * FROM " . TABLE_ORDERS . " WHERE orders_id = :ordersID";
$query = $db->bindVars($query, ':ordersID', $response['orderNo'], 'integer');
$result = $db->Execute($query);
if ( !($result->RecordCount() > 0) ){
    $errorMsg = 'The order number does not exist';
    $messageStack->add_session ( 'checkout_payment', $errorMsg, 'error' );
    echo '<script type="text/javascript">top.location.href="' . zen_href_link ( FILENAME_CHECKOUT_PAYMENT, '', 'SSL' ) . '";</script>';
    exit;
}
if ($_GET['respond'] == 'callback'){
    callback($response);
}else{
    notify($response);
}

function callback($response){
    global $messageStack;
    $signSrc   = md5($response['merNo'] . $response['data'] . $response['code'] . $response['md5Key'] . $response['timestamp']); //校验源字符串
    if (!empty($response['data'])){
        if ($signSrc == $response['sign']){
            $notify = 0;
            $comment = "[ - Trade No:" . $response['tradeNo'] ." -Order No:" . $response['orderNo'] . " -Code:" . $response['code']  . " -Message:" . $response['msg'] . "]";
            if($response['code']=='88'){
                $notify = 1;
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_SUCCESS_ID;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL', true, false));
            }else if($response['code'] == '99'){
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_TEST_SUCCESS_ID;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
                $messageStack->add_session('checkout_payment', $response['msg'], $response['type']);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT,'', 'SSL', true, false));
            }else if($response['code'] == '19'){
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID;
                $notify = 1;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
                $messageStack->add_session('checkout_payment', $response['msg'], $response['type']);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT,'', 'SSL', true, false));
            }else{
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID;
                $notify = 1;
                $msg = str_replace('@@@', $response['msg'], $response['payFailure']);
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
                $messageStack->add_session('checkout_payment', $msg, $response['type']);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT,'', 'SSL', true, false));
            }
        }else{
            //exit('Signature verification error!');
            $messageStack->add_session ( 'checkout_payment', $response['msg'], 'error' );
            echo '<script type="text/javascript">top.location.href="' . zen_href_link ( FILENAME_CHECKOUT_PAYMENT, '', 'SSL' ) . '";</script>';
            exit;
        }
    }else{
        //exit('Trading data is empty.Payment timeout!');
        $messageStack->add_session ( 'checkout_payment', $response['msg'], 'error' );
        echo '<script type="text/javascript">top.location.href="' . zen_href_link ( FILENAME_CHECKOUT_PAYMENT, '', 'SSL' ) . '";</script>';
        exit;
    }
}

function notify($response){
    $signSrc   = md5($response['merNo'] . $response['data'] . $response['code'] . $response['md5Key'] . $response['timestamp']); //校验源字符串
    if (!empty($response['data'])){
        if ($signSrc == $response['sign']){
            $notify = 0;
            $comment = "[tradeNO:" . $response['tradeNo'] ." -orderID:" . $response['orderNo'] . " -status:" . $response['status']  . " -Message:" . $response['msg'] . "]";
            if($response['code']=='88'){
                $notify = 1;
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_SUCCESS_ID;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
                header('Content-Type: text/plain');
                exit('SUCCESS');
            }else if($response['code'] == '99'){
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_TEST_SUCCESS_ID;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
            }else if($response['code'] == '19'){
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID;
                $notify = 1;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
            }else{
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID;
                $notify = 1;
                update_order_status($response['orderNo'], $status_id, $notify, $comment);
            }
        }else{
            exit('Signature verification error!');
        }
    }else{
        exit('Trading data is empty.Payment timeout!');
    }
}

function certification3d($response) {
    // 3d验证
    if (isset($response['certification3d']) && $response['certification3d'] == true ){
        if (isset($response['certificationType']) && $response['certificationType'] == 'html'){
            $html_src = base64_decode($response['html']);
            exit($html_src);
        }
        if (isset($response['certificationType']) && $response['certificationType'] == 'url'){
            $url = isset($response['url']) ? base64_decode($response['url']) : '';
            if (!isset($response['params']) || $response['params'] == ''){
                header('location:'.urldecode($url));
                exit;
            }
            $form = '';
            $params = isset($response['params']) ? base64_decode($response['params']) : '';
            if ($params != ''){
                $params_arr = json_decode($params,true);
                if ( is_array($params_arr) && !empty($params_arr)){
                    foreach ($params_arr as $key => $value){
                        $form .= '<input type="hidden" name="'.$key.'" value="'.$value.'" />'.PHP_EOL;
                    }
                }
            }
            $certification_form = <<<EOF
                <form name="sendCertification3d" action="{$url}" method="post" >
                    {$form}
                </form>
                <div style="margin:0 auto;width:460px; height:32px;overflow:hidden"><img style="width:32px;height:32px;float:left" src="funiu/images/loading.gif"/><span style="padding:0px 10px;font-size:16px;line-height:32px;color:#000;float:left;">Requesting payment, please wait a moment ...</span></div>';
                <script type="text/javascript">
                    setTimeout(function() {
                        document.createElement('form').submit.call(document.sendCertification3d);
                    }, 100);
                </script>
EOF;
            exit($certification_form);
        }
    }
}

function update_order_status($order_id, $status_id, $notify = 0, $comment){
    global $db;
    $check_status = $db->Execute("select customers_name, customers_email_address, orders_status, date_purchased from " . TABLE_ORDERS . " where orders_id = '" . (int) $order_id . "'");
    if(($check_status->fields['orders_status'] != $status_id)){
        $db->Execute("update " . TABLE_ORDERS . " set orders_status = '" . zen_db_input($status_id) . "', last_modified = now() where orders_id = '" . (int) $order_id . "'");
        $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . zen_db_input($order_id) . "','" . zen_db_input($status_id) . "',now(),'" . zen_db_input($notify) . "','".$comment."')");
        if ($notify) {
            $query = "SELECT customers_firstname, customers_lastname, customers_email_address FROM ".TABLE_CUSTOMERS." WHERE customers_id = (SELECT customers_id FROM ".TABLE_ORDERS." WHERE orders_id = ':ordersID')";
            $query = $db->bindVars($query, ':ordersID', (int)$order_id, 'integer');
            $result = $db->Execute($query);
            $customers = $result->fields;
            $customersName = $customers['customers_firstname'].'&nbsp;'.$customers['customers_lastname'];
            $customersEmail= $customers['customers_email_address'];

            $email_text = EMAIL_FAIL_FUNIU_MSG;
            if($status_id == MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_SUCCESS_ID){
                $email_text = EMAIL_SUCCESS_FUNIU_MSG;
            }

            $query_products = "SELECT products_name, products_quantity FROM ".TABLE_ORDERS_PRODUCTS." WHERE orders_id = ':ordersID'";
            $query_products = $db->bindVars($query_products, ':ordersID', (int)$order_id, 'integer');
            $products = $db->Execute($query_products);
            $products_arr =array();
            while (!$products->EOF){
                $products_arr[] = array(
                    'name' => $products->fields['products_name'],
                    'qty' => $products->fields['products_quantity']
                );
                $products->MoveNext();
            }
            $products_order = '';
            for($i = 0, $n = sizeof ( $products_arr ); $i < $n; $i ++) {
                $products_order .= '<p>'.$products_arr[$i]['name'].' x '.$products_arr[$i]['qty'].'</p>';
            }
            $detailedMessage = date('M-d-Y h:i:s')."\n=================================\r\n";
            $detailedMessage .='Invoice No '.$order_id."\n";
            $detailedMessage .='Products '."\n".$products_order."\n";
            $detailedMessage .='Comments '.$comment."\n";
            $detailedMessage .='Order Link '.ORDERLINK . (int)$order_id."\n";
            zen_mail($customersName, $customersEmail, EMAIL_SUBJECT_FUNIU_MSG, $email_text.' Order number: '.(int)$order_id . " Link: " . ORDERLINK . (int)$order_id, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, array('EMAIL_MESSAGE_HTML'=>nl2br($detailedMessage)));
        }
    }
}

function curl_request($url,$method='get',$postData=null)
{
    global $messageStack;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); // 跳过主机检查
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array());
    curl_setopt($ch, CURLOPT_REFERER, $_SERVER['HTTP_REFERER']);
    curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
    if ($method == 'post' && $postData != null){
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,$postData );
    }
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);//将curl_exec()获取的信息以字符串返回
    curl_setopt($ch, CURLOPT_TIMEOUT, 90);
    $response = curl_exec($ch);
    if(curl_errno($ch)){
        $err = 'Curl error: ' . curl_error($ch);
        $messageStack->add_session('checkout_payment', $err, 'error');
        zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
    }
    curl_close($ch);
    return $response;
}
function get_payment_config(){
    $language = get_browser_lang();
    if (stristr($language,'cn')){
        $language = 'en';
    }elseif (stristr($language,'tw')){
        $language = 'tw';
    }else{
        $language = substr($language,0,2);
    }
    $req_url = 'https://payment.139.mx/getPayConfig.do';
    $req_url = $req_url.'?Lang='.$language;
    $config = curl_request($req_url);
    return $config;
}
function get_browser_lang() {
    $acceptLan = '';
    if(isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) && !empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])){
        $acceptLan = explode(',',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
        $acceptLan = $acceptLan[0];
    }
    return $acceptLan;
}
include(DIR_WS_INCLUDES . 'application_bottom.php');

?>