<?php
/**
 * funiu payment method class
 *
 * @package paymentMethod
 * @copyright Copyright 2003-2012 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version GIT: $Id: Author: HuaByte  Wed Jun 26 11:26:39 2019 -0400 Modified in v1.5.1 $
 */
class funiu extends base
{
    /**
     * $code determines the internal 'code' name used to designate "this" payment module
     *
     * @var string
     */
    var $code;
    /**
     * $title is the displayed name for this payment method
     *
     * @var string
     */
    var $title;
    /**
     * $description is a soft name for this payment method
     *
     * @var string
     */
    var $description;
    /**
     * $enabled determines whether this module shows or not... in catalog.
     *
     * @var boolean
     */
    var $enabled;
    /**
     * log file folder
     *
     * @var string
     */
    var $_logDir = '';
    /**
     * vars
     */
    var $funiu_config ='';
    var $gateway_mode;
    var $order_prefix;
    var $order_prefix_status;
    var $cmsVersion;
    var $order_status;
    var $form_action_url;
    const XIN_VERSION = 'v3.01';

    function funiu()
    {
        global $order;
        $this->code = 'funiu';
        if (IS_ADMIN_FLAG === true) {
            $this->title = MODULE_PAYMENT_FUNIU_TEXT_ADMIN_TITLE; // Payment module title in Admin
        } else {
            $this->title = MODULE_PAYMENT_FUNIU_TEXT_CATALOG_TITLE; // Payment module title in Catalog
        }
        $this->description = MODULE_PAYMENT_FUNIU_TEXT_DESCRIPTION;
        $this->enabled = ((MODULE_PAYMENT_FUNIU_STATUS == 'True') ? true : false);
        $this->order_prefix_status = ((MODULE_PAYMENT_FUNIU_ORDER_PREFIX_STATUS == 'True') ? true : false);
        $this->sort_order = MODULE_PAYMENT_FUNIU_SORT_ORDER;

        if ((int)MODULE_PAYMENT_FUNIU_ORDER_STATUS_ID > 0) {
            $this->order_status = MODULE_PAYMENT_FUNIU_ORDER_STATUS_ID;
        }

        if (is_object($order)) $this->update_status();

        include_once(dirname(__FILE__) . '/../../version.php');
        $this->cmsVersion = PROJECT_VERSION_MAJOR . "." . PROJECT_VERSION_MINOR;

        if ($this->order_prefix_status == true){
            $this->order_prefix = defined('MODULE_PAYMENT_FUNIU_ORDER_PREFIX') ? MODULE_PAYMENT_FUNIU_ORDER_PREFIX.'-fn' : '';
        }
        $this->_logDir = defined('DIR_FS_LOGS') ? DIR_FS_LOGS : DIR_FS_SQL_CACHE;
        $this->gateway_mode = defined('MODULE_PAYMENT_FUNIU_GATEWAY_MODE')?MODULE_PAYMENT_FUNIU_GATEWAY_MODE:'iframe';
        defined('MODULE_PAYMENT_FUNIU_GATEWAY_URL')?MODULE_PAYMENT_FUNIU_GATEWAY_URL:'https://payment.139.mx/Pay.do';
        defined('MODULE_PAYMENT_FUNIU_GATEWAY_URL_IFRAME')?MODULE_PAYMENT_FUNIU_GATEWAY_URL_IFRAME:'https://payment.139.mx/showPay.do';
        $this->funiu_config = $this->get_payment_config();
        $this->cc_type = $this->get_cc_type();
        $this->form_action_url = MODULE_PAYMENT_FUNIU_GATEWAY_URL;
        if (MODULE_PAYMENT_FUNIU_GATEWAY_MODE == 'iframe'){
            $this->form_action_url = MODULE_PAYMENT_FUNIU_GATEWAY_URL_IFRAME;
        }
    }

    function update_status()
    {
        global $order, $db;
        if (($this->enabled == true) && ((int) MODULE_PAYMENT_FUNIU_ZONE > 0)){
            $check_flag = false;
            $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_FUNIU_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
            while (!$check_query->EOF) {
                if ($check_query->fields['zone_id'] < 1) {
                    $check_flag = true;
                    break;
                } elseif ($check_query->fields['zone_id'] == $order->billing['zone_id']) {
                    $check_flag = true;
                    break;
                }
                $check_query->MoveNext();
            }
            if ($check_flag == false) {
                $this->enabled = false;
            }
        }
    }

    function javascript_validation() {
        if ($this->gateway_mode == 'iframe') return false;
        $js = ' if (payment_value == "' . $this->code . '") {' . "\n" .
            '       var cc_number = document.checkout_payment.' . $this->code . '_cc_number.value;' . "\n" .
            '       var cc_cvv = document.checkout_payment.' . $this->code . '_cc_cvv.value;' . "\n";

        $js .= '    cc_number = cc_number.replace(/\s+/g,"");' . "\n";

        $js .= '    if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
            '           error_message = error_message + "' . MODULE_PAYMENT_FUNIU_TEXT_JS_CC_NUMBER . '";' . "\n" .
            '           error = 1;' . "\n" .
            '       }' . "\n";

        $js .= '    if (cc_cvv == "" || cc_cvv.length < "3" || cc_cvv.length > "4") {' . "\n".
            '           error_message = error_message + "' . MODULE_PAYMENT_FUNIU_TEXT_JS_CC_CVV . '";' . "\n" .
            '           error = 1;' . "\n" .
            '       }' . "\n" ;

        $js .= '}' . "\n";
        return $js;
    }

    /**
     * Display Credit Card Information Submission Fields on the Checkout Payment Page
     *
     * @return array
     */
    function selection() {
        global $order;
        //$content = '';
        //$content = zen_draw_hidden_field('funiu_xCookie','','id="funiu_xCookie"').'<script type="text/javascript" src="https://risk.xriskop.com/sslcsid.js"></script><script>function getCookie(keys){var arr=document.cookie.split(";");for(var i=0; i<arr.length; i++){var ass=arr[i].split("=");if(ass[0].trim()==keys){return ass[1];}}return false;}document.getElementById("funiu_xCookie").value = getCookie("XCookie")</script>';
        for ($i=1; $i<13; $i++) {
            $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%m',mktime(0,0,0,$i,1,2000)));
        }
        $today = getdate();
        for ($i=$today['year']; $i < $today['year']+10; $i++) {
            $expires_year[] = array('id' => strftime('%Y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
        }
        $types = $this->cc_type;
        foreach ($types as $value){
            $funiu_type[] = array(
                'id'   => $value,
                'text' => $value
            );
        }
        $config = array();
        if ( isset($_SESSION['funiu_config']) && $_SESSION['funiu_config'] != ''){
            $config_temp = json_decode($_SESSION['funiu_config'],true);
            $config['cardType'] = isset($config_temp['messages']['cardType']) ? $config_temp['messages']['cardType'] : '';
            $config['cardNumber'] = isset($config_temp['messages']['cardNumber']) ? $config_temp['messages']['cardNumber'] : '';
            $config['expirationDate'] = isset($config_temp['messages']['expirationDate']) ? $config_temp['messages']['expirationDate'] : '';
            $config['cvv'] = isset($config_temp['messages']['cvv']) ? $config_temp['messages']['cvv'] : '';
            $config['whatIsThis'] = isset($config_temp['messages']['whatIsThis']) ? $config_temp['messages']['whatIsThis'] : '';
        }else{
            $payment_config = $this->get_payment_config();
            $config_temp = json_decode($payment_config,true);
            $config['cardType'] = isset($config_temp['messages']['cardType']) ? $config_temp['messages']['cardType'] : '';
            $config['cardNumber'] = isset($config_temp['messages']['cardNumber']) ? $config_temp['messages']['cardNumber'] : '';
            $config['expirationDate'] = isset($config_temp['messages']['expirationDate']) ? $config_temp['messages']['expirationDate'] : '';
            $config['cvv'] = isset($config_temp['messages']['cvv']) ? $config_temp['messages']['cvv'] : '';
            $config['whatIsThis'] = isset($config_temp['messages']['whatIsThis']) ? $config_temp['messages']['whatIsThis'] : '';
        }
        $cardType_text = ( isset($config['cardType']) && $config['cardType'] != '' )? $config['cardType'] : MODULE_PAYMENT_FUNIU_TEXT_CREDIT_CARD_TYPE;
        $cardNumber_text = ( isset($config['cardNumber']) && $config['cardNumber'] != '' )? $config['cardNumber'] : MODULE_PAYMENT_FUNIU_TEXT_CREDIT_CARD_NUMBER;
        $expirationDate_text = ( isset($config['expirationDate']) && $config['expirationDate'] != '' )? $config['expirationDate'] : MODULE_PAYMENT_FUNIU_TEXT_CREDIT_CARD_EXPIRES;
        $cvv_text = ( isset($config['cvv']) && $config['cvv'] != '' )? $config['cvv'] : MODULE_PAYMENT_FUNIU_TEXT_CVV;
        $whatIsThis_text = ( isset($config['whatIsThis']) && $config['whatIsThis'] != '' )? $config['whatIsThis'] : MODULE_PAYMENT_FUNIU_TEXT_POPUP_CVV_LINK;
        $onFocus = ' onfocus="methodSelect(\'pmt-' . $this->code . '\')"';
        $payment_icon = $this->get_payment_icons();
        $payment_title = '<img src="./funiu/images/'.$payment_icon.'.png" title="' . MODULE_PAYMENT_FUNIU_MARK_BUTTON_ALT . '" style="height: 36px;vertical-align: middle;" /> &nbsp;' . '<span class="smallText">' . MODULE_PAYMENT_FUNIU_TEXT_CATALOG_TITLE . '</span>';
        if ( $this->gateway_mode == 'iframe'){
            $selection = array(
                'id' => $this->code,
                'module' => $payment_title
            );
        }else{
            $selection = array('id' => $this->code,
                'module' => $payment_title,
                'fields' => array(
                    array(
                        'title' => $cardType_text,
                        'field' => '<div>'.zen_draw_pull_down_menu('funiu_cc_type', $funiu_type,'Visa', 'id="'.$this->code.'-cc-type"' . $onFocus).'</div>',
                        'tag' => $this->code.'-cc-type'),
                    array(
                        'title' => $cardNumber_text,
                        'field' => '<div>'.zen_draw_input_field('funiu_cc_number', '', 'id="'.$this->code.'-cc-number"' . $onFocus . ' autocomplete="off"').'</div>',
                        'tag' => $this->code.'-cc-number'),
                    array(
                        'title' => $expirationDate_text,
                        'field' => '<div>'.
                            zen_draw_pull_down_menu('funiu_cc_expires_month', $expires_month, strftime('%m'), 'id="'.$this->code.'-cc-expires-month"' . $onFocus) . '&nbsp;' .
                            zen_draw_pull_down_menu('funiu_cc_expires_year', $expires_year, '', 'id="'.$this->code.'-cc-expires-year"' . $onFocus).
                            '</div>',
                        'tag' => $this->code.'-cc-expires-month'),
                    array(
                        'title' => $cvv_text,
                        'field' => '<div style="float:left;padding-bottom:5px;width: 100%;">'.
                            zen_draw_input_field('funiu_cc_cvv', '', 'size="4" maxlength="4"' . ' id="'.$this->code.'-cc-cvv"' . $onFocus . ' autocomplete="off"') . ' ' . '<a href="javascript:popupWindow(\'' . zen_href_link(FILENAME_POPUP_CVV_HELP) . '\')" style="padding-left:5px;">' . $whatIsThis_text . '</a>'.'</div><div class="clear"></div>'.
                            zen_draw_hidden_field('funiu_cc_ip', '', ' id="'.$this->code.'-cc-ip" autocomplete="off"').
                            '<div style="float:left;padding-bottom:5px;width: 100%;">'.
                            zen_image('./funiu/images/mcafee-secure.png','','','','style="display:block;float:left;height:24px;width:auto;border-image:none;margin-right:5px;"').
                            zen_image('./funiu/images/norton-symantec.png','','','','style="display:block;float:left;height:24px;width:auto;border-image:none;margin-right:5px;"').
                            zen_image('./funiu/images/pci-dss.png','','','','style="display:block;float:left;height:24px;width:auto;border-image:none;"').
                            '</div>'.
                            '<div style="display:none">'.zen_draw_hidden_field('funiu_cc_screen','','id="'.$this->code.'-cc-resolution" value="" ').zen_draw_hidden_field('funiu_cc_timezone','','id="'.$this->code.'-cc-timezone" value="" ').zen_draw_hidden_field('funiu_cc_os','','id="'.$this->code.'-cc-os" value="" ').'<script type="application/javascript" src="https://pv.sohu.com/cityjson?ie=utf-8"></script><script type="application/javascript" src="funiu/js/payform.js"></script><script type="application/javascript" src="funiu/js/funiu.js"></script></div>',
                        'tag' => $this->code.'-cc-cvv'),
                )
            );
        }
        return $selection;
    }
    /**
     * Evaluates the Credit Card Type for acceptance and the validity of the Credit Card Number & Expiration Date
     *
     */
    function pre_confirmation_check() {
        global $messageStack;
        // 创建订单
        $this->confirmation();
        if ($this->gateway_mode == 'iframe'){
            return false;
        }else{
            if (isset($_POST['funiu_cc_number'])) {
                include(DIR_WS_CLASSES . 'cc_validation.php');
                $cc_validation = new cc_validation();
                $result = $cc_validation->validate($_POST['funiu_cc_number'], $_POST['funiu_cc_expires_month'], $_POST['funiu_cc_expires_year']);
                $error = '';
                switch ($result) {
                    case -1:
                        $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
                        break;
                    case -2:
                    case -3:
                    case -4:
                        $error = TEXT_CCVAL_ERROR_INVALID_DATE;
                        break;
                    case false:
                        $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
                        break;
                }
                if ( ($result == false) || ($result < 1) ) {
                    $messageStack->add_session('checkout_payment', $error . '<!-- ['.$this->code.'] -->', 'error');
                    zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
                }
                $this->cc_card_type    = $cc_validation->cc_type;
                $this->cc_card_number  = $cc_validation->cc_number;
                $this->cc_expiry_month = $cc_validation->cc_expiry_month;
                $this->cc_expiry_year  = $cc_validation->cc_expiry_year;
                $_SESSION['additionInfo']['cardNo'] = $this->cc_card_number;
                $_SESSION['additionInfo']['expireYear'] = $this->cc_expiry_year;
                $_SESSION['additionInfo']['expireMonth'] = $this->cc_expiry_month;
                $_SESSION['additionInfo']['cvv'] = $_POST['funiu_cc_cvv'];
                $_SESSION['additionInfo']['os'] = $_POST['funiu_cc_os'];
                $_SESSION['additionInfo']['screen'] = $_POST['funiu_cc_screen'];
                $_SESSION['additionInfo']['timezone'] = $_POST['funiu_cc_timezone'];
                if (strtolower($this->cc_card_type) == 'mastercard'){
                    $this->cc_card_type = 'master';
                }
                $cc_card_str = $this->get_cc_cards_str();
                // 提示：不支持该卡交易
                if(!stristr($cc_card_str,$this->cc_card_type)){
                    $error = '* Sorry, '.$this->cc_card_type.' credit card payment is not supported, or we do not accept that kind of card. Please try again or use another credit card. Example:'.$cc_card_str.'\n';
                    $messageStack->add_session('checkout_payment', $error . '<!-- ['.$this->code.'] -->', 'error');
                    zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
                }
                $result = $this->payment_submit();
                $this->payment_response($result);
                return false;
            }
        }

    }

    /**
     * Display Credit Card Information for review on the Checkout Confirmation Page
     *
     * @return array
     */
    function confirmation() {
        $confirmation = array('title' => MODULE_PAYMENT_FUNIU_TEXT_CATALOG_GATEWAY_TITLE);
        return $confirmation;
    }

    function create_order(){
        global $order,$order_total_modules,$order_totals,$insert_id;
        if (!$_SESSION['customer_id']){
            zen_redirect(zen_href_link(FILENAME_TIME_OUT));
        }else{
            if (zen_get_customer_validate_session($_SESSION['customer_id']) == false){
                $_SESSION['navigation']->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_SHIPPING));
                zen_redirect(zen_href_link(FILENAME_LOGIN, '', 'SSL'));
            }
        }
        if (sizeof($order->products) < 1){
            zen_redirect(zen_href_link(FILENAME_SHOPPING_CART));
        }
        $order->info['payment_method'] = MODULE_PAYMENT_FUNIU_TEXT_CATALOG_TITLE;
        $order->info['payment_module_code'] = $this->code;
        $order->info['order_status'] = MODULE_PAYMENT_FUNIU_ORDER_STATUS_ID;

        $order_totals = $order_total_modules->pre_confirmation_check();
        $order_totals = $order_total_modules->process();
        $insert_id = $order->create($order_totals, 2);
        // store the product info to the order
        $order->create_add_products($insert_id);
        $order->info['order_id'] = $insert_id;
        $_SESSION['order_id'] = $insert_id;
    }

    /**
     * 更新订单状态
     * @param $order_id
     * @param $status_id
     * @param $transactionid
     * @param int $notify
     */
    function update_order_status($order_id, $status_id, $notify = 0, $comment){
        global $db;
        $check_status = $db->Execute("select customers_name, customers_email_address, orders_status, date_purchased from " . TABLE_ORDERS . " where orders_id = '" . (int) $order_id . "'");
        if(($check_status->fields['orders_status'] != $status_id)){
            $db->Execute("update " . TABLE_ORDERS . " set orders_status = '" . zen_db_input($status_id) . "', last_modified = now() where orders_id = '" . (int) $order_id . "'");
            $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . zen_db_input($order_id) . "','" . zen_db_input($status_id) . "',now(),'" . zen_db_input($notify) . "','".$comment."')");
        }
    }

    /**
     * Build the data and actions to process when the "Submit" button is pressed on the order-confirmation screen.
     * This sends the data to the payment gateway for processing.
     * (These are hidden fields on the checkout confirmation page)
     *
     * @return string
     */
    function process_button() {
        $process_button_string = "\r\n";
        $submit_data = $this->request_form_data();
        //$this->write_log($submit_data);
        $funiu_path = DIR_WS_CATALOG.'funiu';
        $ref = $_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        $ref = urlencode($ref);
        $merchant_no = $submit_data['merchantNo'];
        $data_str    = $submit_data['data'];
        $timestamp   = $submit_data['timestamp'];
        $language    = $submit_data['language'];
        $version     = $submit_data['version'];
        $iframe      = $submit_data['iframe'];
        $sign        = $submit_data['sign'];
        $is_mobile   = $iframe;
        $gateway_url = $this->form_action_url;
        $process_button_string .= <<<EOT
        <link rel="stylesheet" href="{$funiu_path}/css/style.css" />
        <script type="text/javascript" src="{$funiu_path}/js/jquery-1.10.2.js"></script>
        <script type="text/javascript" src="{$funiu_path}/js/jquery-migrate-1.2.1.js"></script>
        <script type="text/javascript" src="{$funiu_path}/js/jquery-box.js"></script>
        <script type="text/javascript">
            var metaList = document.getElementsByTagName("meta");
            var metaViewport = 0;
            for (var i = 0; i < metaList.length; i++) {
                if (metaList[i].getAttribute("name") == "viewport") {
                    var metaViewport = 1;
                    metaList[i].content = "width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0";
                }
            }
            if( metaViewport == 0){
                var oMeta = document.createElement('meta');
                oMeta.name = 'viewport';
                oMeta.content = 'width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0';
                document.getElementsByTagName('head')[0].appendChild(oMeta);
            }
            document.body.addEventListener("touchstart", function() {})
            var mo = function(e) {
                e.preventDefault()
            };
            function payment(){
                var params = {"merchantNo":"{$merchant_no}","data":"{$data_str}","timestamp":"{$timestamp}","language":"{$language}","version":"{$version}","iframe":"{$iframe}","sign":"{$sign}","ref":"{$ref}"};
                var method = "post";
                var isMobile = "{$is_mobile}";
                if(isMobile == 0){
                    msgBox.show({"url": "{$gateway_url}", "w": 460, "h": 284, "isMobile":0,"params":params,"method":method});
                }else{
                    var height = document.body.offsetHeight;
                    var width = document.body.offsetWidth;
                    msgBox.show({"url": "{$gateway_url}", "w": width, "h": height, "isMobile":1,"params":params,"method":method});
                    document.addEventListener("touchmove", mo, {
                        passive: false
                    }); //禁止页面滑动
                }
            };
            window.addEventListener("message",function(e){
                var res = e.data;
                if(res.code == "close"){
                    msgBox.remove();
                }else if(res.code == "setHeight"){
                    msgBox.setSize(res.data.width,res.data.height);
                }else if(res.code == "redirect"){
                    document.write(res.data.html);
                    document.pay_sumbit_form.submit();
                }else if(res.code == 'showBox'){
                    msgBox.showBox();
                }
            },false);
            payment();
        </script>
EOT;
        //$this->write_log($process_button_string);
        exit($process_button_string);
    }

    /**
     * Store the CC info to the order and process any results that come back from the payment gateway
     *
     */
    function before_process() {
        return false;
    }

    /**
     * Post-processing activities
     *
     * @return boolean
     */
    function after_process() {
        return false;
    }

    /**
     * Check to see whether module is installed
     * @return mixed
     */
    function check() {
        global $db;
        if (!isset($this->_check)) {
            $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_FUNIU_STATUS'");
            $this->_check = $check_query->RecordCount();
        }
        return $this->_check;
    }

    /**
     * Install the payment module and its configuration settings
     *
     */
    function install() {
        global $db, $messageStack, $module_type;
        if (defined('MODULE_PAYMENT_FUNIU_STATUS')) {
            $messageStack->add_session('funiu module already installed.', 'error');
            zen_redirect(zen_href_link(FILENAME_MODULES, 'set=payment&module=funiu', 'NONSSL'));
            return 'failed';
        }

        // 自定义订单状态=》待处理Pay_pending[CreditCard Payment]
        $query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Pay_pendding[CreditCard Payment]' limit 1");
        if ($query->RecordCount() < 1) {
            $status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
            $status_id = $status_query->fields['status_id'] + 1;
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '1', 'Pay_pendding[CreditCard Payment]')");
        } else {
            $status_id = $query->fields['orders_status_id'];
        }
        // 自定义订单状态=》成功Pay_success[CreditCard Payment]
        $query_success = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Pay_success[CreditCard Payment]' limit 1");
        if ($query_success->RecordCount() < 1) {
            $status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
            $pay_success_status_id = $status_query->fields['status_id'] + 1;
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $pay_success_status_id . "', '1', 'Pay_success[CreditCard Payment]')");
        } else {
            $pay_success_status_id = $query_success->fields['orders_status_id'];
        }

        // 自定义订单状态=》测试成功Pay_test[CreditCard Payment]
        $query_test = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Pay_test[CreditCard Payment]' limit 1");
        if ($query_test->RecordCount() < 1) {
            $status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
            $test_success_status_id = $status_query->fields['status_id'] + 1;
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $test_success_status_id . "', '1', 'Pay_test[CreditCard Payment]')");
        } else {
            $test_success_status_id = $query_test->fields['orders_status_id'];
        }
        // 自定义订单状态=》失败Pay_fail[CreditCard Payment]
        $query_fail = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Pay_fail[CreditCard Payment]' limit 1");
        if ($query_fail->RecordCount() < 1) {
            $status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
            $pay_fail_status_id = $status_query->fields['status_id'] + 1;
            $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $pay_fail_status_id . "', '1', 'Pay_fail[CreditCard Payment]')");
        } else {
            $pay_fail_status_id = $query_fail->fields['orders_status_id'];
        }

        //模块激活
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,set_function, date_added) values ('Enable funiu Payment Module', 'MODULE_PAYMENT_FUNIU_STATUS', 'True', 'Do you want to accept funiu payments?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
        //商户ID
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added) values('Merchant ID','MODULE_PAYMENT_FUNIU_SELLER','10003','Merchant ID','6','0',now())");
        //商户密钥
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,date_added) values('Merchant MD5 key','MODULE_PAYMENT_FUNIU_MD5KEY','12345678','Merchant MD5 key','6','0',now())");
        //区域
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,use_function,set_function,date_added) values('Payment Zone','MODULE_PAYMENT_FUNIU_ZONE','0','If a zone is selected, only enable this payment method for that zone.','6','0','zen_get_zone_class_title','zen_cfg_pull_down_zone_classes(',now())");

        //默认订单状态
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set CreditCard Preparing Status', 'MODULE_PAYMENT_FUNIU_ORDER_STATUS_ID', '" . $status_id . "', 'Set the status of orders made with this payment module to this value<br />(No payment [CreditCard Payment]: recommended)', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
        //订单支付成功
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function,use_function, date_added) values('Payment Successfull order status', 'MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_SUCCESS_ID', '" . $pay_success_status_id . "', 'Set your order status for order pay_success', '6', '0','zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
        //订单支付失败
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function,use_function, date_added) values ('Payment failed order status', 'MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID', '" . $pay_fail_status_id . "', 'Set your order status for order pay_fail', '6', '0','zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
        //订单测试成功
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function,use_function, date_added) values ('Test Successfull order status', 'MODULE_PAYMENT_FUNIU_ORDER_STATUS_TEST_SUCCESS_ID', '" . $test_success_status_id . "', 'Set your order status for order test_success', '6', '0','zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
        //排序
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Sort order of display','MODULE_PAYMENT_FUNIU_SORT_ORDER','0','Sort order of display. Lowest is displayed first.','6','0',now())");
        //支付方式
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Payment methods', 'MODULE_PAYMENT_FUNIU_GATEWAY_MODE', 'direct', 'Where should customer credit card info be collected?<br/><b>direct payment</b> = here (requires SSL)<br/><b>iframe pages payment</b> = iframe 139.mx checkout pages', '6', '0', 'zen_cfg_select_option(array(\'direct\',  \'iframe\'), ', now())");
        //网关地址
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Direct Payment Gateway URL','MODULE_PAYMENT_FUNIU_GATEWAY_URL','" . "https://payment.139.mx/Pay.do','Direct Payment Request URL','6','0',now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Iframe Checkout Pages Gateway URL','MODULE_PAYMENT_FUNIU_GATEWAY_URL_IFRAME','" . "https://payment.139.mx/showPay.do','Iframe Pages Request URL','6','0',now())");
        //返回地址
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Payment Return URL','MODULE_PAYMENT_FUNIU_RETURN_URL','" . HTTP_SERVER . DIR_WS_CATALOG . "funiu.php','Payment Return URL','6','0',now())");
        //激活订单前缀
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title,configuration_key,configuration_value,configuration_description,configuration_group_id,sort_order,set_function, date_added) values ('Enable funiu order prefix', 'MODULE_PAYMENT_FUNIU_ORDER_PREFIX_STATUS', 'False', 'Do you want to open the order prefix?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . "(configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Order prefix','MODULE_PAYMENT_FUNIU_ORDER_PREFIX','" . "sm-','Customer custom order prefix','6','0',now())");
    }

    /**
     * Remove the module and all its settings
     */
    function remove() {
        global $db;
        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key LIKE 'MODULE\_PAYMENT\_FUNIU\_%'");
    }

    /**
     * Internal list of configuration keys used for configuration of the module
     * @return array
     */
    function keys() {
        return array(
            'MODULE_PAYMENT_FUNIU_STATUS', //模块状态
            'MODULE_PAYMENT_FUNIU_SELLER', //商户账号
            'MODULE_PAYMENT_FUNIU_MD5KEY', //md5key
            'MODULE_PAYMENT_FUNIU_ZONE', //区域
            'MODULE_PAYMENT_FUNIU_ORDER_STATUS_ID', //订单状态id
            'MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_SUCCESS_ID', //订单完成状态
            'MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID',
            'MODULE_PAYMENT_FUNIU_ORDER_STATUS_TEST_SUCCESS_ID',
            'MODULE_PAYMENT_FUNIU_SORT_ORDER', //排序
            'MODULE_PAYMENT_FUNIU_GATEWAY_MODE',//支付方式
            'MODULE_PAYMENT_FUNIU_GATEWAY_URL',//Direct Payment网关地址
            'MODULE_PAYMENT_FUNIU_GATEWAY_URL_IFRAME',//Iframe pages Payment网关地址
            'MODULE_PAYMENT_FUNIU_RETURN_URL', //返回地址
            'MODULE_PAYMENT_FUNIU_ORDER_PREFIX_STATUS',//订单前缀状态
            'MODULE_PAYMENT_FUNIU_ORDER_PREFIX', //订单前缀
        );
    }

    /**
     * 获取用户以及交易，商户信息
     * @return array
     */
    function request_form_data()
    {
        global $order, $currencies;
        // 生成网站订单
        $this->create_order();
        $customer_info = $order->customer;
        $billing_info = $order->billing;
        //账单人姓
        $billingFirstName = zen_not_null($billing_info['firstname']) ? $billing_info['firstname'] : $customer_info['firstname'];
        //账单人名
        $billingLastName = zen_not_null($billing_info['lastname']) ? $billing_info['lastname'] : $customer_info['lastname'];
        //账单人电话
        $billingPhone = zen_not_null($billing_info['telephone']) ? $billing_info['telephone'] : $customer_info['telephone'];
        //账单人邮编
        $billingZip = zen_not_null($billing_info['postcode']) ? $billing_info['postcode'] : $customer_info['postcode'];
        //账单人详细地址
        $billingAddress = $billing_info['street_address'] . $billing_info['suburb'];
        $customerAddress = $customer_info['street_address'] . $customer_info['suburb'];
        $billingAddress = zen_not_null($billingAddress) ? $billingAddress : $customerAddress;
        //账单人城市
        $billingCity = zen_not_null($billing_info['city']) ? $billing_info['city'] : $customer_info['city'];
        //账单人省份/州
        $billingState = zen_not_null($billing_info['state']) ? $billing_info['state'] : $customer_info['state'];
        //账单人国家
        $billingCountry = zen_not_null($billing_info['country']['title']) ? $billing_info['country']['title'] : $customer_info['country']['title'];
        $delivery = $order->delivery;
        $_SESSION['delivery'] = json_encode($delivery).json_encode($billing_info);

        //收货人姓
        $deliveryFirstName = zen_not_null($delivery['firstname']) ? $delivery['firstname'] : $billingFirstName;
        //收货人名
        $deliveryLastName = zen_not_null($delivery['lastname']) ? $delivery['lastname'] : $billingLastName;
        //收货人邮箱
        $deliveryEmail = zen_not_null($delivery['email_address']) ? $delivery['email_address'] : $customer_info['email_address'];
        //收货人电话
        $deliveryPhone = zen_not_null($delivery['telephone']) ? $delivery['telephone'] : $billingPhone;
        //收货人邮编
        $deliveryZip = zen_not_null($delivery['postcode']) ? $delivery['postcode'] : $billingZip;
        //收货人详细地址
        $deliveryAddress = $delivery["street_address"] . $delivery['suburb'];
        $deliveryAddress = zen_not_null($deliveryAddress) ? $deliveryAddress : $billingAddress;
        //收货人城市
        $deliveryCity = zen_not_null($delivery['city']) ? $delivery['city'] : $billingCity;
        //收货人省份/州
        $deliveryState = zen_not_null($delivery['state']) ? $delivery['state'] : $billingCity;
        //收货人国家
        $deliveryCountry = zen_not_null($delivery['country']['title']) ? $delivery['country']['title'] : $billingCountry;
        $countryCode = zen_not_null($delivery['country']['iso_code_2']) ? $delivery['country']['iso_code_2'] : $billing_info['country']['iso_code_2'];

        //订单号(商户网站生成的订单号)
        $billNo = $order->info['order_id'];
        if ($this->order_prefix_status == true){
            $billNo = $this->order_prefix.$billNo;
        }
        //返回地址
        $returnURL = HTTP_SERVER . DIR_WS_CATALOG . 'funiu.php?respond=callback';
        $notifyURL = HTTP_SERVER . DIR_WS_CATALOG . 'funiu.php?respond=notify';
        //时间戳
        $timestamp = time();
        //订单重复验证
        if ($timestamp > (@$_SESSION['cookie'] + 60)) {
            $_SESSION['cookie'] = $timestamp;
        }
        //商户号
        $merNo = MODULE_PAYMENT_FUNIU_SELLER;
        //商户密匙
        $MD5key = MODULE_PAYMENT_FUNIU_MD5KEY;
        $currency = $order->info['currency'];
        $amount = ($order->info['total']) * ($currencies->get_value($currency));
        $amount = number_format($amount, 2,'.','');
        //语言
        $language = strtolower($this->get_language_code());
        $goods = $order->products;
        $count_goods = count($goods, 0);
        $product = array();
        for ($i = 0; $i < $count_goods; $i++) {
            $price = round($goods[$i]['price'] * $currencies->get_value($currency), 2);
            $attr = '';
            if (isset($goods[$i]['attributes']) && sizeof($goods[$i]['attributes']) > 0 ) {
                $option_data = array();
                for ($j=0, $n2=sizeof($goods[$i]['attributes']); $j<$n2; $j++) {
                    $option_data[] = array(
                        'name'  => $goods[$i]['attributes'][$j]['option'],
                        'value' => $goods[$i]['attributes'][$j]['value']
                    );
                }
                foreach ($option_data as $option_attr){
                    $attr .= implode('=',$option_attr).'^';
                }
                $attr = substr($attr,0,-1);
            }
            $product_img = zen_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $goods[$i]['id'], 'SSL', true, false);
            $product_url = $this->get_products_image($goods[$i]['id']);
            $temp = array(
                'name' => $goods[$i]['name'],
                'qty' => $goods[$i]['qty'],
                'price' => $price,
                'attr' => $attr,
                'img' => $product_img,
                'url' => $product_url,
            );
            $product[] = $temp;
        }
        $products = $product;
        $ip = $this->get_ip_address();
        $cartVersion = $this->cmsVersion;
        $cookie = $_SESSION['cookie'];
        if (isset($_POST['funiu_xCookie'])){
            $cookie = $_POST['funiu_xCookie'];
        }
        $os       = $_SESSION['additionInfo']['os'];
        $screen   = $_SESSION['additionInfo']['screen'];
        $timezone = $_SESSION['additionInfo']['timezone'];
        $dataCore = array(
            'products'           => $products,
            //billing info 订单信息
            'billingFirstName'   => $billingFirstName,
            'billingLastName'    => $billingLastName,
            'billingAddress'     => $billingAddress,
            'billingCity'        => $billingCity,
            'billingZip'         => $billingZip,
            'billingState'       => $billingState,
            'billingCountry'     => $billingCountry,
            //delivery info  收货信息
            'deliveryFirstName'  => $deliveryFirstName,
            'deliveryLastName'   => $deliveryLastName,
            'deliveryAddress'    => $deliveryAddress,
            'deliveryCity'       => $deliveryCity,
            'deliveryZip'        => $deliveryZip,
            'deliveryState'      => $deliveryState,
            'deliveryCountry'    => $deliveryCountry,
            'countryCode'        => $countryCode,
            'email'              => $deliveryEmail,
            'telephone'          => $deliveryPhone,
            'cookies'            => $cookie, //，用于辨别重复提交的订单
            'ipAddress'          => $ip,
            'userAgent'          => $_SERVER['HTTP_USER_AGENT'], //客户浏览器UA
            'userLang'           => $_SERVER['HTTP_ACCEPT_LANGUAGE'], //客户浏览器语言
            //持卡人结束
            'serverIp'           => $_SERVER["SERVER_ADDR"], //服务器IP
            'framework'          => "zencart", //购物车系统
            'cmsVersion'         => $cartVersion, //购物车系统版本
            'orderNo'            => $billNo, //商户订单号
            'amount'             => $amount, //订单金额
            'currency'           => $currency, //币种码
            'notifyURL'          => $notifyURL, //通知地址
            'returnURL'          => $returnURL, //返回地址
            'os'                 => $os,
            'screen'             => $screen,
            'timezone'           => $timezone
        );
        if ($this->gateway_mode != 'iframe'){
            $cardNo      = str_replace(' ','',$_SESSION['additionInfo']['cardNo']);
            $cvv         = $_SESSION['additionInfo']['cvv'];
            $expireYear  = $_SESSION['additionInfo']['expireYear'];
            $expireMonth = $_SESSION['additionInfo']['expireMonth'];
            if(strlen($expireMonth) < 2){
                $expireMonth='0'.$expireMonth;
            }
            $dataExtras = array(
                'cardNo'      => $cardNo,
                'CVV2'        => $cvv,
                'ExpireMonth' => $expireMonth,
                'ExpireYear'  => $expireYear
            );
            $dataCore = array_merge($dataExtras,$dataCore);
        }
        $data = json_encode($dataCore);
        //$this->write_log($data);
        $sign = md5($merNo . $data . $MD5key . $timestamp);  //校验源字符串
        $iframe = $this->is_mobile();
        if ($this->gateway_mode == 'iframe'){
            $data = base64_encode($data);
        }
        $formFields = array(
            'merchantNo' => $merNo,
            'data' => $data,
            'timestamp' => $timestamp,
            'language' => $language,
            'version' => self::XIN_VERSION,
            'iframe' => $iframe,
            'sign' =>$sign
        );
        //提交数据日志
        //$this->write_log($formFields);
        return $formFields;
    }

    /**
     * 提交支付
     * @return mixed
     */
    function payment_submit() {
        global $messageStack;
        // 30秒内重复提交无效
        if (isset($_COOKIE['funiu_flag'])){
            $error = 'Your payment has been requested, please do not repeat the submission.';
            $messageStack->add_session('checkout_payment', $error, 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
            exit;
        }
        setcookie('funiu_flag', time(), time() + 30);
        $url_server = $this->form_action_url;
        $data = $this->request_form_data();
        $parameters = http_build_query($data, '', '&');
        $response = $this->curl_request($url_server,'post',$parameters);
        return $response;
    }

    /**
     * 处理支付返回信息以及订单状态
     * @param array $response
     */
    function payment_response($response = null){
        global  $messageStack,$order,$order_total_modules;
        $response = json_decode($response,true);
        // $this->write_log($response);
        unset($_SESSION['funiu_payment_cards']);
        unset($_SESSION['additionInfo']);
        // 3d验证
        if ( $response['code'] == '301'){
            unset($_SESSION['funiu_config']);
            // 3d验证
            $this->certification3d($response);
        }

        if ( empty($response) ){
            //返回数据为空，直接跳转到付款页面
            $messageStack->add_session('checkout_payment', '<span style="font-family:Arial,helvetica,sans-serif;font-size:16px">Payment Error!</span>', 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        }
        if (empty($response['data'])) {
            //返回订单数据为空，直接跳转到付款页面
            $messageStack->add_session('checkout_payment', '<span style="font-family:Arial,helvetica,sans-serif;font-size:16px">'.$response['msg'].'</span>', 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        }
        //交易信息解析
        $data = json_decode(base64_decode($response['data']), true);
        //支付结果状态码
        $code = $response['code'];
        //支付结果返回标示: 88 :表示交易成功 ; 19 表示待处理 ；其他表示交易失败;
        $msg = $response['msg'];
        //获取md5key
        $md5key = trim(MODULE_PAYMENT_FUNIU_MD5KEY);
        //获取商户号
        $merNo = $data['merchantNo'];
        //订单号
        $orderNo = $data['orderNo'];
        if ($this->order_prefix_status == true){
            // 去掉订单前缀
            $orderNo = (int)substr($orderNo, strlen($this->order_prefix));
        }
        //交易流水号
        $tradeNo = $data['tradeNo'];
        //加密数据
        $sign = $response['sign'];
        //时间戳
        $timestamp = $response['timestamp'];
        //数据的组合和加密校验
        $md5src = md5($merNo . $response['data'] . $code . $md5key . $timestamp);
        $config = json_decode($_SESSION['funiu_config'],true);
        unset($_SESSION['funiu_config']);
        if ($sign == $md5src){
            $notify = 0;
            $comment = "[ - Order No:" . $orderNo ." -Trade No:" . $tradeNo . " -Code:" . $response['code']  . " - Transaction Message:" . $response['msg'] . "]";
            if($response['code']=='88'){
                $notify = 1;
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_SUCCESS_ID;
                $this->update_order_status($orderNo, $status_id, $notify, $comment);
                $order->send_order_email($orderNo, 2);
                $order_total_modules->clear_posts();
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL', true, false));
            }else if($response['code'] == '99'){
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_TEST_SUCCESS_ID;
                $this->update_order_status($orderNo, $status_id, $notify, $comment);
                $messageStack->add_session('checkout_payment', $msg, $response['type']);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT,'', 'SSL', true, false));
            }else if($response['code'] == '19'){
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID;
                $notify = 1;
                $this->update_order_status($orderNo, $status_id, $notify, $comment);
                $order->send_order_email($orderNo, 2);
                $messageStack->add_session('checkout_payment', $msg, $response['type']);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT,'', 'SSL', true, false));
            }else{
                $status_id = MODULE_PAYMENT_FUNIU_ORDER_STATUS_PAY_FAIL_ID;
                $notify = 1;
                $msg = str_replace('@@@', $msg, $config['messages']['payFailure']);
                $this->update_order_status($orderNo, $status_id, $notify, $comment);
                $order->send_order_email($orderNo, 2);
                $messageStack->add_session('checkout_payment', $msg, $response['type']);
                zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT,'', 'SSL', true, false));
            }
        }else{
            $messageStack->add_session ( 'checkout_payment', $response['msg'], 'error' );
            echo '<script type="text/javascript">top.location.href="' . zen_href_link ( FILENAME_CHECKOUT_PAYMENT, '', 'SSL' ) . '";</script>';
            exit;
        }
    }

    function certification3d($response) {
        // $this->write_log($response);
        // 3d验证
        if (isset($response['certification3d']) && $response['certification3d'] == true ){
            if (isset($response['certificationType']) && $response['certificationType'] == 'html'){
                $html_src = base64_decode($response['html']);
                exit($html_src);
            }
            if (isset($response['certificationType']) && $response['certificationType'] == 'url'){
                $url = isset($response['url']) ? base64_decode($response['url']) : '';
                if (!isset($response['params']) || $response['params'] == ''){
                    header('location:'.urldecode($url));
                    exit;
                }
                $form = '';
                $params = isset($response['params']) ? base64_decode($response['params']) : '';
                if ($params != ''){
                    $params_arr = json_decode($params,true);
                    if ( is_array($params_arr) && !empty($params_arr)){
                        foreach ($params_arr as $key => $value){
                            $form .= '<input type="hidden" name="'.$key.'" value="'.$value.'" />'.PHP_EOL;
                        }
                    }
                }
                $certification_form = <<<EOF
                <form name="sendCertification3d" action="{$url}" method="post" >
                    {$form}
                </form>
                <div style="margin:0 auto;width:460px; height:32px;overflow:hidden"><img style="width:32px;height:32px;float:left" src="funiu/images/loading.gif"/><span style="padding:0px 10px;font-size:16px;line-height:32px;color:#000;float:left;">Requesting payment, please wait a moment ...</span></div>';
                <script type="text/javascript">
                    setTimeout(function() {
                        document.createElement('form').submit.call(document.sendCertification3d);
                    }, 100);
                </script>
EOF;
                exit($certification_form);
            }
        }
    }

    /**
     * curl_request 通过curl来进行get,post请求
     * @param $url
     * @param string $method
     * @param null $postData
     * @param int $repeat 重复请求次数
     * @return mixed
     */
    function curl_request($url,$method='get',$postData=null,$repeat=2)
    {
        global $messageStack;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); // 跳过主机检查
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array());
        curl_setopt($ch, CURLOPT_REFERER, $_SERVER['HTTP_REFERER']);
        curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
        if ($method == 'post' && $postData != null){
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS,$postData );
        }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);//将curl_exec()获取的信息以字符串返回
        curl_setopt($ch, CURLOPT_TIMEOUT, 90);
        $response = curl_exec($ch);
        if(curl_errno($ch)){
            $err = 'Curl error: ' . curl_error($ch);
            $messageStack->add_session('checkout_payment', $err, 'error');
            $this->write_log($err);
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        }
        curl_close($ch);
        return $response;
    }

    /**
     * 通过普通的http发送post请求
     * http_build_query($post_data, '', '&')用于生成URL-encode之后的请求字符串
     * stream_context_create() 创建并返回一个流的资源
     * @param $url 请求地址
     * @param $data post键值对数据
     * @return false|string
     */
    function http_post($url, $data){
        $ref = empty($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_HOST'] : $_SERVER['HTTP_REFERER'];
        $options  = array(
            'http' => array(
                'method' => "POST",
                'header' => "Accept-language: en\r\n" . "referer:$ref \r\n",
                'content-type' => "multipart/form-data",
                'content' => $data,
                'timeout' => 90
            )
        );
        //创建并返回一个流的资源
        $context  = stream_context_create($options);
        $result   = file_get_contents($url, false, $context);
        return $result;
    }

    function get_cc_cards_str(){
        if (isset($_SESSION['funiu_config']) && $_SESSION['funiu_config'] != ''){
            $response = json_decode($_SESSION['funiu_config'],true);
        }else{
            $payment_config = $this->get_payment_config();
            $response = json_decode($payment_config,true);
        }
        return strtolower($response['cards']);
    }

    function get_cc_type(){
        if (isset($_SESSION['funiu_config']) && $_SESSION['funiu_config'] != ''){
            $response = json_decode($_SESSION['funiu_config'],true);
        }else{
            $payment_config = $this->get_payment_config();
            $response = json_decode($payment_config,true);
        }
        $arr = explode(',',strtolower($response['cards']));
        $card_arr = array();
        foreach ($arr as $v){
            if ($v == 'visa'){
                $card_arr[$v] = 'Visa';
            } elseif ($v == 'mastercard' || $v == 'master'){
                $card_arr[$v] = 'MasterCard';
            } elseif ($v == 'jcb'){
                $card_arr[$v] = 'JCB';
            } elseif ($v == 'amex'){
                $card_arr[$v] = 'American Express';
            } elseif ($v == 'discover'){
                $card_arr[$v] = 'Discover';
            } else {
                $card_arr[$v] = 'other';
            }
        }
        if (in_array('Visa',$card_arr)){
            $card_arr_s['visa'] = 'Visa';
        }
        if (in_array('MasterCard',$card_arr)){
            $card_arr_s['master'] = 'MasterCard';
        }
        if (in_array('JCB',$card_arr)){
            $card_arr_s['jcb'] = 'JCB';
        }
        if (in_array('American Express',$card_arr)){
            $card_arr_s['amex'] = 'American Express';
        }
        if (in_array('Discover',$card_arr)){
            $card_arr_s['discover'] = 'Discover';
        }
        $_SESSION['funiu_payment_cards'] = $card_arr_s;
        return $card_arr_s;
    }

    function get_payment_icons(){
        if (isset($_SESSION['funiu_payment_cards']) && !empty($_SESSION['funiu_payment_cards']) ){
            $payment_cards = $_SESSION['funiu_payment_cards'];
        }else{
            $payment_cards = $this->get_cc_type();
        }
        $payment_icon = '';
        if (in_array('Visa',$payment_cards)){
            $payment_icon .= 'visa-';
        }
        if (in_array('MasterCard',$payment_cards)){
            $payment_icon .= 'master-';
        }
        if (in_array('JCB',$payment_cards)){
            $payment_icon .= 'jcb-';
        }
        if (in_array('American Express',$payment_cards)){
            $payment_icon .= 'amex-';
        }
        if (in_array('Discover',$payment_cards)){
            $payment_icon .= 'discover-';
        }
        $payment_icon = trim($payment_icon,'-');
        return $payment_icon;
    }

    function is_mobile() {
        // 如果有HTTP_X_WAP_PROFILE则一定是移动设备
        if (isset($_SERVER['HTTP_X_WAP_PROFILE'])) {
            return 1;
        }
        if (isset($_SERVER['HTTP_CLIENT']) && 'PhoneClient' == $_SERVER['HTTP_CLIENT']) {
            return 1;
        }
        if (isset($_SERVER['HTTP_VIA'])){
            return stristr($_SERVER['HTTP_VIA'], 'wap') ? 1 : 0;//找不到为flase,否则为true
        }
        if (isset($_SERVER['HTTP_USER_AGENT'])) {
            $clientkeywords = array(
                'nokia', 'sony', 'ericsson', 'mot', 'samsung', 'htc', 'sgh', 'lg', 'sharp', 'sie-', 'philips', 'panasonic', 'alcatel', 'lenovo', 'iphone', 'ipod', 'blackberry', 'meizu', 'android', 'netfront', 'symbian', 'ucweb', 'windowsce', 'palm', 'operamini', 'operamobi', 'openwave', 'nexusone', 'cldc', 'midp', 'wap', 'mobile',
            );
            //从HTTP_USER_AGENT中查找手机浏览器的关键字
            if (preg_match("/(" . implode('|', $clientkeywords) . ")/i", strtolower($_SERVER['HTTP_USER_AGENT']))) {
                return 1;
            }
        }
        if (isset($_SERVER['HTTP_ACCEPT'])) {
            // 如果只支持wml并且不支持html那一定是移动设备
            // 如果支持wml和html但是wml在html之前则是移动设备
            if ((strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html')))) {
                return 1;
            }
        }
        return 0;
    }

    /**
     * Determine the language to use when visiting the PayPal site
     */
    function get_language_code() {
        global $order;
        $lang_code = '';
        $orderISO = zen_get_countries($order->customer['country']['id'], true);
        $storeISO = zen_get_countries(STORE_COUNTRY, true);
        if (in_array(strtoupper($orderISO['countries_iso_code_2']), array('US', 'AU', 'DE', 'FR', 'IT', 'GB', 'ES', 'AT', 'BE', 'CA', 'CH', 'CN', 'NL', 'PL'))) {
            $lang_code = strtoupper($orderISO['countries_iso_code_2']);
        } elseif (in_array(strtoupper($storeISO['countries_iso_code_2']), array('US', 'AU', 'DE', 'FR', 'IT', 'GB', 'ES', 'AT', 'BE', 'CA', 'CH', 'CN', 'NL', 'PL'))) {
            $lang_code = strtoupper($storeISO['countries_iso_code_2']);
        } elseif (in_array(strtoupper($_SESSION['languages_code']), array('EN', 'US', 'AU', 'DE', 'FR', 'IT', 'GB', 'ES', 'AT', 'BE', 'CA', 'CH', 'CN', 'NL', 'PL'))) {
            $lang_code = $_SESSION['languages_code'];
        }
        if (strtoupper($lang_code) == 'US') $lang_code = 'EN';
        return strtoupper($lang_code);
    }

    function get_ip_address() {
        if (isset($_SERVER)) {
            if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
                $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
            } elseif (isset($_SERVER['HTTP_CLIENT_IP'])) {
                $ip = $_SERVER['HTTP_CLIENT_IP'];
            }elseif (isset($_SERVER['HTTP_X_FORWARDED'])) {
                $ip = $_SERVER['HTTP_X_FORWARDED'];
            } elseif (isset($_SERVER['HTTP_X_CLUSTER_CLIENT_IP'])) {
                $ip = $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
            } elseif (isset($_SERVER['HTTP_FORWARDED_FOR'])) {
                $ip = $_SERVER['HTTP_FORWARDED_FOR'];
            } elseif (isset($_SERVER['HTTP_FORWARDED'])) {
                $ip = $_SERVER['HTTP_FORWARDED'];
            } elseif(isset($_SERVER['HTTP_X_REAL_IP'])){
                $ip = $_SERVER['HTTP_X_REAL_IP'];
            } else {
                $ip = $_SERVER['REMOTE_ADDR'];
            }
        } else {
            if (getenv('HTTP_X_FORWARDED_FOR')) {
                $ip = getenv('HTTP_X_FORWARDED_FOR');
            } elseif (getenv('HTTP_CLIENT_IP')) {
                $ip = getenv('HTTP_CLIENT_IP');
            } elseif (getenv('HTTP_X_REAL_IP')) {
                $ip = getenv('HTTP_X_REAL_IP');
            } else {
                $ip = getenv('REMOTE_ADDR');
            }
        }
        $ip = explode ( ",", $ip );
        return $ip[0];
    }

    public function get_payment_config(){
        $language = $this->get_browser_lang();
        if (stristr($language,'cn')){
            $language = 'en';
        }elseif (stristr($language,'tw')){
            $language = 'tw';
        }else{
            $language = substr($language,0,2);
        }
        $site = $_SERVER['HTTP_HOST'];
        $timestamp = time();
        //商户号
        $merNo = MODULE_PAYMENT_FUNIU_SELLER;
        //商户密匙
        $MD5key = MODULE_PAYMENT_FUNIU_MD5KEY;
        $sign = md5($merNo . $site . $timestamp . $MD5key);
        $fields = array(
            'Lang' => $language,
            'merchantNo' =>$merNo,
            'website' => $site,
            'timestamp' => $timestamp,
            'sign' => $sign
        );
        $parms = http_build_query($fields,'','&');
        $req_url = 'https://payment.139.mx/getPayConfig.do';
        $config = $this->curl_request($req_url,'post',$parms);
        $config_arr = json_decode($config,true);
        if ($config_arr['status'] !=1){
            $req_url = $req_url.'?Lang='.$language;
            $config = $this->curl_request($req_url);
            $config_arr_temp = json_decode($config,true);
            $config_arr_temp['cards'] = 'visa,master,jcb';
            $config = json_encode($config_arr_temp);
        }
        //$this->write_log($config);
        $_SESSION['funiu_config'] = $config;
        return $config;
    }

    public function get_browser_lang() {
        $acceptLan = '';
        if(isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) && !empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])){
            $acceptLan = explode(',',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
            $acceptLan = $acceptLan[0];
        }
        return $acceptLan;
    }

    function get_products_image($product_id) {
        global $db;
        $sql = "select p.products_image from " . TABLE_PRODUCTS . " p  where products_id='" . (int)$product_id . "'";
        $look_up = $db->Execute($sql);
        if (ENABLE_SSL == 'true') {
            $url =  HTTPS_SERVER ;
        } else {
            $url =   HTTP_SERVER ;
        }
        return $url . '/' . DIR_WS_IMAGES  . $look_up->fields['products_image'];
    }

    function write_log($msg){
        date_default_timezone_set('Asia/Shanghai');
        $errorMessage = str_pad(date('Y-m-d H:i:s').' [Message]',80,'=',STR_PAD_RIGHT)."\n";
        $errorMessage .= print_r($msg, true) . "\n".str_pad('[EndMessage]',80,'=',STR_PAD_RIGHT)."\r\n";
        $file = $this->_logDir.'/'.basename(__FILE__,'.php').'-'.date('Y-m-d').'.log';
        $fp = @fopen($file, 'a');
        @fwrite($fp, $errorMessage);
        @fclose($fp);
    }




}